#!/bin/sh

VERSION='$Id: sm_ctrld.sh,v 1.7 2009/04/17 07:54:28 sesam Exp $'

# READ INI
read_ini()
{
  SM_INI=`grep -i '^sm_ini=' /etc/sesam2000.ini|cut -d"=" -f2`
  echo `grep -i "$1=" "$SM_INI"|cut -d"=" -f2`
}

set_env()
{
   for e in `sed -n '/\[ENVIRONMENT]/,/^\[/p' \`grep -i '^sm_ini=' /etc/sesam2000.ini|cut -d"=" -f2\`|sed -n '/^[^#].*=/p'`
   do
      eval $e
      #export ${e%=*}
      export `echo $e|cut -d '=' -f 1`
   done
env
}

# KILL ACTIVE JOB
sub_kill_job()
{
  column_opt=""             # ps option to print output with nnn columns
  psopts="-e -o pid,comm"
  [ "`uname`" = "Darwin" ] && psopts="auw"
  [ "`uname`" = "FreeBSD" ] && psopts="axo"
  [ "`uname`" = "Linux" ] && column_opt="--cols 132"

  ps $psopts $column_opt | grep $1 | grep -v grep | grep -v $MYSELF >/dev/null 2>&1
  STATUS=$? 
  # no process found
  [ "$STATUS" != 0 ] && return 0
  if [ "$STATUS" = "0" ]
  then
    echo "FOUND ACTIVE ${1}. WILL REMOVE"
    ps $psopts $column_opt|grep $1|grep -v grep|grep -v $MYSELF
    ps $psopts $column_opt|grep $1|grep -v grep|grep -v $MYSELF|awk '{print $1}'|xargs -n1 kill $2
  fi
  return 1
}


 
# STOP OR START sm_ctrld_main
sub_env()
{
  GV_RO=/sesam/
  GV_RO=`read_ini gv_ro`

  if [ "$1" = "stop" -o "$1" = "STOP" ]
  then
    SWITCH="stop"
  else
    SWITCH="start"
  fi
}


# MAIN PROCEDURE
sub_main()
{
  sub_kill_job sbc$ -2
  if [ "$?" != "0" ]
  then
    sleep 10
    sub_kill_job sbc$ -9
  fi

  if [ "$SWITCH" = "start" ] 
  then 
    echo "TRY TO START sm_ctrld_main"
    set_env
    nohup ${GV_RO}bin/sesam/sm_ctrld_main >/dev/null 2>&1 </dev/null &
    STATUS=$?
    if [ "$STATUS" = "0" ]
    then
      echo "DONE"
      exit 0
    else
      echo "FAIL TO START sm_ctrld_main"
      exit 1
    fi

  else
    echo "TRY TO STOP sm_ctrld_main"
    sub_kill_job sm_ctrld
    sleep 2 
    echo "DONE"
    exit 0
  fi

}

# MAIN
MYSELF=$0

# SBC ENV TIMEOUT
SBC_GEN_WAIT=1800
SBC_DATA_WAIT=1800
export SBC_GEN_WAIT
export SBC_DATA_WAIT


# RUN SUB
sub_env $1
sub_main



